#ifndef EFL_GENERATED_ECORE_AUDIO_IN_SNDFILE_HH
#define EFL_GENERATED_ECORE_AUDIO_IN_SNDFILE_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "ecore_audio_in_sndfile.eo.h"
}

#include "ecore_audio_in.eo.hh"
#include <string>

struct ecore_audio_in_sndfile
      : ecore_audio_in
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit ecore_audio_in_sndfile(Eo* eo)
      : ecore_audio_in(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit ecore_audio_in_sndfile(std::nullptr_t)
      : ecore_audio_in(nullptr)
   {}

   /// @brief Call the object's constructor.
   /// Should not be used with #eo_do. Only use it with #eo_do_super.
   ///
   ecore_audio_in_sndfile(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : ecore_audio_in_sndfile(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   ecore_audio_in_sndfile(ecore_audio_in_sndfile const& other)
      : ecore_audio_in(eo_ref(other._eo_ptr()))
   {}

   ~ecore_audio_in_sndfile() {}

   /// @brief Set the source of the object
   ///
   /// What sources are supported depends on the actual object. For example,
   /// the libsndfile class accepts WAV, OGG, FLAC files as source.
   ///
   /// @since 1.8
   ///
   /// @param source 
   ///
   bool source_set(std::string source_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::ecore_audio_obj_source_set(efl::eolian::to_c(source_)));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief Get the source of the object
   ///
   /// @since 1.8
   ///
   /// @param source 
   ///
   std::string source_get() const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::ecore_audio_obj_source_get());
      return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief Set the format of the object
   ///
   /// What formats are supported depends on the actual object. Default is
   /// ECORE_AUDIO_FORMAT_AUTO
   ///
   /// @since 1.8
   ///
   /// @param format 
   ///
   bool format_set(Ecore_Audio_Format format_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::ecore_audio_obj_format_set(format_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief Get the format of the object
   ///
   /// After setting the source if the format was ECORE_AUDIO_FORMAT_AUTO this
   /// function will now return the actual format.
   ///
   /// @since 1.8
   ///
   /// @param format 
   ///
   Ecore_Audio_Format format_get() const
   {
      Ecore_Audio_Format _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::ecore_audio_obj_format_get());
      return _tmp_ret;
   }

   /// @brief Set the virtual IO functions
   ///
   /// @since 1.8
   ///
   /// @param vio 
   /// @param data 
   /// @param free_func 
   ///
   void vio_set(Ecore_Audio_Vio * vio_, void * data_, eo_key_data_free_func free_func_) const
   {
      eo_do(_eo_ptr(), ::ecore_audio_obj_vio_set(vio_, data_, free_func_));
   }

   /// @brief Seek within the input
   ///
   /// @since 1.8
   ///
   /// @param offs 
   /// @param mode 
   ///
   double seek(double offs_, int mode_) const
   {
      double _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::ecore_audio_obj_in_seek(offs_, mode_));
      return _tmp_ret;
   }

   /// @brief Internal read function
   ///
   /// @since 1.8
   ///
   /// @param buf 
   /// @param len 
   ///
   ssize_t read_internal(void * buf_, size_t len_) const
   {
      ssize_t _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::ecore_audio_obj_in_read_internal(buf_, len_));
      return _tmp_ret;
   }

   static Eo_Class const* _eo_class()
   {
      return(ECORE_AUDIO_IN_SNDFILE_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_ref(ECORE_AUDIO_IN_SNDFILE_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
bool _ecore_audio_in_sndfile_source_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * source_)
{
   return static_cast<T*>(self->this_)->source_set(efl::eolian::to_cxx<std::string>(source_, std::tuple<std::false_type>()));
}

template <typename T>
std::string _ecore_audio_in_sndfile_source_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->source_get();
}

template <typename T>
bool _ecore_audio_in_sndfile_format_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Ecore_Audio_Format format_)
{
   return static_cast<T*>(self->this_)->format_set(format_);
}

template <typename T>
Ecore_Audio_Format _ecore_audio_in_sndfile_format_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->format_get();
}

template <typename T>
void _ecore_audio_in_sndfile_vio_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Ecore_Audio_Vio * vio_, void * data_, eo_key_data_free_func free_func_)
{
   static_cast<T*>(self->this_)->vio_set(vio_, data_, free_func_);
}

template <typename T>
double _ecore_audio_in_sndfile_seek_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double offs_, int mode_)
{
   return static_cast<T*>(self->this_)->seek(offs_, mode_);
}

template <typename T>
ssize_t _ecore_audio_in_sndfile_read_internal_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, void * buf_, size_t len_)
{
   return static_cast<T*>(self->this_)->read_internal(buf_, len_);
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::ecore_audio_in_sndfile >
{
   template <typename T>
   struct type
   {
      virtual bool source_set(std::string source_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::ecore_audio_obj_source_set(efl::eolian::to_c(source_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual std::string source_get()
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::ecore_audio_obj_source_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool format_set(Ecore_Audio_Format format_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::ecore_audio_obj_format_set(format_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual Ecore_Audio_Format format_get()
      {
         Ecore_Audio_Format _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::ecore_audio_obj_format_get());
            return _tmp_ret;
      }

      virtual void vio_set(Ecore_Audio_Vio * vio_, void * data_, eo_key_data_free_func free_func_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::ecore_audio_obj_vio_set(vio_, data_, free_func_));
      }

      virtual double seek(double offs_, int mode_)
      {
         double _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::ecore_audio_obj_in_seek(offs_, mode_));
            return _tmp_ret;
      }

      virtual ssize_t read_internal(void * buf_, size_t len_)
      {
         ssize_t _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::ecore_audio_obj_in_read_internal(buf_, len_));
            return _tmp_ret;
      }

   };
};


template<>
struct operation_description_class_size< ::ecore_audio_in_sndfile >
{
   static const int value = 7;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::ecore_audio_in_sndfile>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_ecore_audio_in_sndfile_source_set_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_source_set);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_ecore_audio_in_sndfile_source_get_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_source_get);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_ecore_audio_in_sndfile_format_set_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_format_set);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_ecore_audio_in_sndfile_format_get_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_format_get);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_ecore_audio_in_sndfile_vio_set_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_vio_set);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_ecore_audio_in_sndfile_seek_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_in_seek);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_ecore_audio_in_sndfile_read_internal_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_in_read_internal);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::ecore_audio_in_sndfile >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::ecore_audio_in_sndfile, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::ecore_audio_in_sndfile >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::ecore_audio_in_sndfile, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::ecore_audio_in_sndfile>
{
   template <typename U>
   struct type
   {
      operator ::ecore_audio_in_sndfile() const
      {
         return ::ecore_audio_in_sndfile(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      bool source_set(std::string source_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::ecore_audio_obj_source_set(efl::eolian::to_c(source_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      std::string source_get()
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::ecore_audio_obj_source_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      bool format_set(Ecore_Audio_Format format_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::ecore_audio_obj_format_set(format_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      Ecore_Audio_Format format_get()
      {
         Ecore_Audio_Format _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::ecore_audio_obj_format_get());
            return _tmp_ret;
      }

      void vio_set(Ecore_Audio_Vio * vio_, void * data_, eo_key_data_free_func free_func_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::ecore_audio_obj_vio_set(vio_, data_, free_func_));
      }

      double seek(double offs_, int mode_)
      {
         double _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::ecore_audio_obj_in_seek(offs_, mode_));
            return _tmp_ret;
      }

      ssize_t read_internal(void * buf_, size_t len_)
      {
         ssize_t _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::ecore_audio_obj_in_read_internal(buf_, len_));
            return _tmp_ret;
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::ecore_audio_in_sndfile>)
{
   return (ECORE_AUDIO_IN_SNDFILE_CLASS);
}

} } }
#endif // EFL_GENERATED_ECORE_AUDIO_IN_SNDFILE_HH

